#!/usr/bin/env python

import sys
import collections

class boxcar_average:
	def __init__(self, average_over, average_attr=None, independant_total_attr=None):
		if average_attr == None and independant_total_attr != None:
			sys.stderr.write('%s: Internal error: average_attr is none but independant_total_attr is not\n' % sys.argv[0])
			sys.exit(1)
		self.average_over = average_over
		self.average_attr = average_attr
		self.independant_total_attr = independant_total_attr
		self.max_size = average_over
		self.index = 0
		self.lst = []
		self.full = False
		self.sum = 0
		if self.independant_total_attr != None:
			self.independant_total = 0

	# We return an object that has an .average attribute.
	# If given an independant_total_attr, we also return an independant_total attribute that's the sum of a field that's -not- used in the average,
	# so we can say "We had an average of x over time interval y".
	def add(self, obj):
		if self.full:
			old_obj = self.lst[self.index]
			self.lst[self.index] = obj
		else:	
			if len(self.lst) == self.index:
				self.lst.append(obj)
			else:
				sys.stderr.write('%s: Internal error: weird lst length\n' % sys.argv[0])
				sys.exit(1)
		if self.average_attr == None:
			new_value = self.lst[self.index]
		else:
			new_value = getattr(self.lst[self.index], self.average_attr)
			new_value_for_independant_total = getattr(self.lst[self.index], self.independant_total_attr)
		if self.full:
			if self.average_attr == None:
				old_value = old_obj
			else:
				old_value = getattr(old_obj, self.average_attr)
				old_value_for_independant_total = getattr(old_obj, self.independant_total_attr)
			self.sum = self.sum + new_value - old_value
			if self.independant_total_attr != None:
#				print 'self.independant_total: %f,  new_value_for_independant_total: %f, old_value_for_independant_total: %f' % \
#					(self.independant_total, new_value_for_independant_total, old_value_for_independant_total)
				self.independant_total = self.independant_total + new_value_for_independant_total - old_value_for_independant_total
		else:
			self.sum += new_value
			if self.independant_total_attr != None:
				self.independant_total += new_value_for_independant_total
		if self.index >= self.max_size - 1:
			self.full = True
		if self.full:
			average = float(self.sum) / self.max_size
		else:
			average = None
		self.index = (self.index + 1) % self.max_size
		nt = collections.namedtuple('average', 'independant_total')
		nt.average = average
		if self.independant_total_attr != None:
			nt.independant_total = self.independant_total
		return nt

if __name__ == '__main__':
#	ba = boxcar_average(3)
#	for value in [ 1, 2, 3, 4, 5, 8, 10 ]:
#		result = ba.add(value)
#		print result.average
#	ba = boxcar_average(5)
#	for value in [ 1, 2, 3, 4, 5, 8, 10, 20, 30, 40, 50 ]:
#		result = ba.add(value)
#		print result.average
	class tc: # test_class
		def __init__(self, fred, barney):
			self.fred = fred
			self.barney = barney
	ba = boxcar_average(2, average_attr='fred', independant_total_attr='barney')
	for value in [ tc(1, 1), tc(2, 2), tc(3, 3), tc(4, 4), tc(5, 5), tc(8, 6), tc(10, 7), tc(20, 8), tc(30, 9), tc(40, 10), tc(50, 11) ]:
		result = ba.add(value)
		print result.average, result.independant_total
	ba = boxcar_average(5, average_attr='fred', independant_total_attr='barney')
	for value in [ tc(1, 1), tc(2, 1), tc(3, 1), tc(4, 1), tc(5, 1), tc(8, 1), tc(10, 1), tc(20, 1), tc(30, 1), tc(40, 1), tc(50, 1) ]:
		result = ba.add(value)
		print result.average, result.independant_total

